<?php

function remove_unused_markers($text, $delim="~~")
{
  // this regex should match a PHP symbol name enclosed in '~~' delimiters
  $result = preg_replace("/".$delim."[a-zA-Z_][a-zA-Z0-9_]*".$delim."/", " ", $text);
  return $result;
}

function cleantext($text) {
	return trim(htmlspecialchars(stripSlashesConditional($text)));
}



function checkChecked($var, $check)
{
	if($var == $check)
		return " checked ";
}


function createRandomPagesLinks($array, $glue="<BR>", $maxEntries=25, $fileExtension, $target="_self")
{
  
  if (!is_array($array)) { return false; }

  $count = count($array);
  if ($count == 0) {
    return "";
  } else if ($count == 1) {

	reset($array);
    $filename = convert_filename(current($array)); 
    return "<a href='" . $filename[0] . $fileExtension . "' target='" . $target . "'>" . current($array) . "</a>";
  
  } else {
    
	$keys = array_rand($array, min($maxEntries, count($array)));
    foreach ($keys as $key) {
      $filename = convert_filename($array[$key]); 
      $values[] = "<a href='" . $filename[0] . $fileExtension . " 'target='" . $target . "'>" . $array[$key] . "</a>";
    }
    return implode("$glue", $values);

  }


}


function assc_shuffle($orig_array) {
	srand ((double) microtime() * 10000000);
	for($i=0;$i < count($orig_array);$i++) {
			$map[] = $i;
	}
	shuffle($map);
	foreach($map as $mk=>$mv) {
		$wait=0;
		foreach($orig_array as $ok=>$ov) {
		if ($mv == $wait) {
			$proc_array[$ok] = $ov;
			break;
		}
		$wait++;
	}
	}
	return $proc_array;
}



function fileize($name) {
	return str_replace("/", "", str_replace("\"", "", str_replace(" ", "-", trim($name))));
}



function transhtml($str) {
		return preg_replace("/\&apos;/i", "'", html_entity_decode($str));
}



function error($msgError) {
	$obj = new form_fields();
	require("includes/errorButtons.php");
	exit();
}



function unhtmlentities ($text)
{

	/**************************************
	Swaps special ASCII chars that are not HTML compatible.
	/**************************************/			
	$this->saveEntities[130] = '&sbquo;';
	$this->saveEntities[132] = '&dbquo;';
	$this->saveEntities[134] = '&dagger;';
	$this->saveEntities[135] = '&Dagger;';
	$this->saveEntities[136] = '&#136;';
	$this->saveEntities[137] = '&permil;';
	$this->saveEntities[138] = '&#138;';
	$this->saveEntities[139] = '&lsaquo;';
	$this->saveEntities[145] = '&lsquo;';
	$this->saveEntities[146] = '&rsquo;';
	$this->saveEntities[147] = '&ldquo;';
	$this->saveEntities[148] = '&rdquo;';
	$this->saveEntities[149] = '&#149;';
	$this->saveEntities[150] = '&ndash;';
	$this->saveEntities[151] = '&mdash;';
	$this->saveEntities[152] = '&tilde';
	$this->saveEntities[153] = '&trade;';
	$this->saveEntities[154] = '&#154;';
	$this->saveEntities[155] = '&rsaquo;';
	$this->saveEntities[156] = '&#156;';
	$this->saveEntities[157] = '&#157;';
	$this->saveEntities[158] = '&#158;';
	$this->saveEntities[159] = '&Yuml;';
	$this->saveEntities[160] = '&#160;';
	$this->saveEntities[161] = '&iexcl;';
	$this->saveEntities[162] = '&cent;';
	$this->saveEntities[163] = '&pound;';
	$this->saveEntities[164] = '&curren;';
	$this->saveEntities[165] = '&yen;';
	$this->saveEntities[166] = '&brvbar;';
	$this->saveEntities[167] = '&sect;';
	$this->saveEntities[168] = '&uml;';
	$this->saveEntities[169] = '&copy;';
	$this->saveEntities[170] = '&ordf;';
	$this->saveEntities[171] = '&laquo;';
	$this->saveEntities[172] = '&not;';
	$this->saveEntities[173] = '&shy;';
	$this->saveEntities[174] = '&reg;';
	$this->saveEntities[175] = '&macr;';
	$this->saveEntities[176] = '&deg;';
	$this->saveEntities[177] = '&plusmn;';
	$this->saveEntities[178] = '&sup2;';
	$this->saveEntities[179] = '&sup3;';
	$this->saveEntities[180] = '&#180;';
	$this->saveEntities[181] = '&micro;';
	$this->saveEntities[182] = '&para;';
	$this->saveEntities[183] = '&middot;';
	$this->saveEntities[184] = '&cedil;';
	$this->saveEntities[185] = '&sup1;';
	$this->saveEntities[186] = '&ordm;';
	$this->saveEntities[187] = '&raquo;';
	$this->saveEntities[188] = '&frac14;';
	$this->saveEntities[189] = '&frac12;';
	$this->saveEntities[190] = '&frac34;';
	$this->saveEntities[191] = '&#191;';
	$this->saveEntities[192] = '&Agrave;';
	$this->saveEntities[193] = '&Aacute;';
	$this->saveEntities[194] = '&Acirc;';
	$this->saveEntities[195] = '&Atilde;';
	$this->saveEntities[196] = '&Auml;';
	$this->saveEntities[197] = '&Aring;';
	$this->saveEntities[198] = '&AElig;';
	$this->saveEntities[199] = '&Ccedil;';
	$this->saveEntities[200] = '&Egrave;';
	$this->saveEntities[201] = '&Eacute;';
	$this->saveEntities[202] = '&Ecirc;';
	$this->saveEntities[203] = '&Euml;';
	$this->saveEntities[204] = '&Igrave;';
	$this->saveEntities[205] = '&Iacute;';
	$this->saveEntities[206] = '&Icirc;';
	$this->saveEntities[207] = '&Iuml;';
	$this->saveEntities[208] = '&ETH;';
	$this->saveEntities[209] = '&Ntilde;';
	$this->saveEntities[210] = '&Ograve;';
	$this->saveEntities[211] = '&Oacute;';
	$this->saveEntities[212] = '&Ocirc;';
	$this->saveEntities[213] = '&Otilde;';
	$this->saveEntities[214] = '&Ouml;';
	$this->saveEntities[215] = '&times;';
	$this->saveEntities[216] = '&Oslash;';
	$this->saveEntities[217] = '&Ugrave;';
	$this->saveEntities[218] = '&Uacute;';
	$this->saveEntities[219] = '&Ucirc;';
	$this->saveEntities[220] = '&Uuml;';
	$this->saveEntities[221] = '&Yacute;';
	$this->saveEntities[222] = '&THORN;';
	$this->saveEntities[223] = '&szlig;';
	$this->saveEntities[224] = '&agrave;';
	$this->saveEntities[225] = '&aacute;';
	$this->saveEntities[226] = '&acirc;';
	$this->saveEntities[227] = '&atilde;';
	$this->saveEntities[228] = '&auml;';
	$this->saveEntities[229] = '&aring;';
	$this->saveEntities[230] = '&aelig;';
	$this->saveEntities[231] = '&ccedil;';
	$this->saveEntities[232] = '&egrave;';
	$this->saveEntities[233] = '&eacute;';
	$this->saveEntities[234] = '&ecirc;';
	$this->saveEntities[235] = '&euml;';
	$this->saveEntities[236] = '&igrave;';
	$this->saveEntities[237] = '&iacute;';
	$this->saveEntities[238] = '&icirc;';
	$this->saveEntities[239] = '&iuml;';
	$this->saveEntities[240] = '&eth;';
	$this->saveEntities[241] = '&ntilde;';
	$this->saveEntities[242] = '&ograve;';
	$this->saveEntities[243] = '&oacute;';
	$this->saveEntities[244] = '&ocirc;';
	$this->saveEntities[245] = '&otilde;';
	$this->saveEntities[246] = '&ouml;';
	$this->saveEntities[247] = '&divide;';
	$this->saveEntities[248] = '&oslash;';
	$this->saveEntities[249] = '&ugrave;';
	$this->saveEntities[250] = '&uacute;';
	$this->saveEntities[251] = '&ucirc;';
	$this->saveEntities[252] = '&uuml;';
	$this->saveEntities[253] = '&yacute;';
	$this->saveEntities[254] = '&thorn;';
	$this->saveEntities[255] = '&yuml;'; 

	// loop through text and replace special chars.
	for ($i=0; $i<strlen($text); $i++) {
	
		$char = substr($text, $i, 1);
		$ascii = ord($char);
		
		if ( !isset($saveEntities[$ascii]) ) {
			$newtext .= $char;
		} else {
			$newtext .= $saveEntities[$ascii];
			$file_changed = true;
		}

	}


	// takes care of the strings PHP has already in place for translaction.
    $trans_tbl = get_html_translation_table (HTML_ENTITIES);
    $trans_tbl = array_flip ($trans_tbl);
    $newtext = strtr ($newtext, $trans_tbl);


	return $newtext;



}



// prints out the HTML / JavaScript for the popup config boxes.
function create_popup_contents($filename, $js_variable) {

	$xmlUser = new XML(APPSETTINGS_FILENAME);
	$savedPassword = $xmlUser->nodes["/applicationSettings[1]/authentication[1]/password[1]"]["text"];

	$fp = fopen($filename, "r");
	$popup_contents = fread($fp, filesize($filename));
	$popup_contents = addslashes($popup_contents);
	$popup_contents = str_replace("\n", "", $popup_contents);
	$popup_contents = str_replace("\r", "", $popup_contents);
	$popup_contents = str_replace("\$password", $savedPassword, $popup_contents);
?>

	<Script Language="JavaScript">
		var <?php echo $js_variable; ?> = "<?php echo $popup_contents; ?>";
	</Script>

<?php

}






// This function converts all the non supported characters to "_" in any string
function convert_filename($filename) {

	$newfilename = "";
	$file_changed = false;
	
	$filename = str_replace("\n", "", $filename);
	$filename = str_replace("\r", "", $filename);

	for ($i=0; $i<strlen($filename); $i++) {
	
		$char = substr($filename, $i, 1);
		$ascii = ord($char);
		if (($ascii == 46) || ($ascii >=48 && $ascii <=57) || ($ascii >=65 && $ascii <=90) || ($ascii >=97 && $ascii <=122)) {
			$newfilename .= $char;
		} else {
			$newfilename .= "_";
			$file_changed = true;
		}

	}



	// in case the very last char was in valid I want it to not return "_" so we don't have the name cars_.html etc.
	if ( substr($newfilename, strlen($newfilename)-1, strlen($newfilename)) == "_") { 
		$newfilename = substr($newfilename, 0, strlen($newfilename)-1);
	}

	return array($newfilename, $file_changed);

}






function echo_badchar_msg($file) {
	
	echo "All spaces and illegal characters like slashes have been changed in the \n";
	$count = 0;

	while(list($key, $val) = each($file)) {
		if(empty($count)) {
			echo "\"$val";
		}
		else {
			echo " and $val";
		}
		$count++;
	}

	echo "\". If you want to change this, please go back to the earlier step.\n";

}




// IMPORT KEYWORDS FROM A KEYWORD FILE
function parseKeywordsCSV($file) {

	if (!$file) {

		return false;

	} elseif ($fp = @fopen($file, "r")) {
		
		while (!feof($fp)) {
			$ukeys .= @fread($fp, 906240);
		}

		fclose($fp);

		if ($ukeys) {
			return str_replace("||||", "\n", cleantext($ukeys) );
		} else {
			return false;
		}


	}


}








// CHANGE THE ADMIN PASSWORD.
function changePassword($pw) {

	global $messages;

	$xml = new XML(APPSETTINGS_FILENAME);

	$xml->set_content("/applicationSettings[1]/authentication[1]/password[1]", $pw);

	$xml->save();

	return $messages['changePasswordSuccess'];

}







// CHANGE THE FTP INFO.
function changeFtpInfo($ftpUsername, $ftpPassword, $ftpServer, $ftpWebRoot) {

	global $messages;

	$xml = new XML(APPSETTINGS_FILENAME);

	$xml->set_content("/applicationSettings[1]/ftp[1]/customer[1]/server[1]", $ftpServer);
	$xml->set_content("/applicationSettings[1]/ftp[1]/customer[1]/username[1]", $ftpUsername);
	$xml->set_content("/applicationSettings[1]/ftp[1]/customer[1]/password[1]", $ftpPassword);
	$xml->set_content("/applicationSettings[1]/ftp[1]/customer[1]/webRoot[1]", $ftpWebRoot);

	$xml->save();

	return $messages['ftpInfoSuccess'];

}








// loading a session from a previous save for a particular step.
function loadSession($currentSessionName, $step, $makeDefault = false) {

	global $messages;
	global $config_fields;
	global $config_action;

	$session_values = array();
	$xml = new XML("./settings/sessions.xml");

	// get all the names for the children of the parent session and step we need.
	$session = @array_keys($xml->nodes["/sessions[1]/" . $currentSessionName . "[1]/" . $step . "[1]"]["children"]);

	// perhaps the sessions file has been edited and this step does not exist.
	if (!$session) { return false; }



	// We're loading a session other than the default so it needs to be set to default.
	if ($makeDefault) {

			foreach ($config_action as $step) {

					foreach ($config_fields[$step] as $element) {			
						$value = $xml->nodes["/sessions[1]/" . $currentSessionName . "[1]/" . $step . "[1]/" . $element . "[1]"]["text"];
						$path = "/sessions[1]/default[1]/" . $step . "[1]/" . $element . "[1]";

						$xml->set_content($path, trim($value));
						//echo "path: " . $path . " ----- value: " . $value . "<br><br>";			
					}

			}

		// saving the current data to be the default as the last used session should be the default.
		$xml->save();

	}

	// Get the session in an array.
	$ret = $xml->get_xml_array($currentSessionName);

	return $ret;
		

}






/* 
 * Loading the current settings for this step into the sessions array to track the settings. 
 * This does not save to the XML file but keeps the same formatting.
 */
function preserveSessionSettings($step, $currentSessionName, $sessionVar) {

	global $HTTP_POST_VARS;
	global $config_fields;

	// we're not posting to exit out with the same data.
	if (!isset($HTTP_POST_VARS["prev_action"])) { return $sessionVar; }

	// Used to exclude fields that have Javascript or the like and we don't want to replace certain chars in.
	$arrExclude = Array( 'googleCode', 'extraHtmlCode' );



	foreach ($config_fields[$step] as $vals) {

		$sessionVar[$currentSessionName][$step][$vals] = $HTTP_POST_VARS[$vals];

		//echo "<br><br>BEFORE - session val: " . $sessionVar[$currentSessionName][$step][$vals] . " : fieldname: " .$vals . " : posted : " . $HTTP_POST_VARS[$vals] . "<br>";

		// Now we need to do some cleanup on the session data.
		if ( !is_array($sessionVar[$currentSessionName][$step][$vals]) ) {
			// strip slashes on all elements that are posted.
			$sessionVar[$currentSessionName][$step][$vals] = trim(stripSlashesConditional($sessionVar[$currentSessionName][$step][$vals]));

			// exclude elements not to be processed for quotes.
			if ( !in_array($vals, $arrExclude) ) {
				$sessionVar[$currentSessionName][$step][$vals] = str_replace("\"", "&quot;", $sessionVar[$currentSessionName][$step][$vals]);
			}
		} 

		// If neither of these two conditions are met we leave if whatever value is in the session settings.
		//echo "AFTER -- session val: " . $sessionVar[$currentSessionName][$step][$vals] . " : fieldname: " .$vals . " : posted : " . $HTTP_POST_VARS[$vals] . "<br>";
		//echo "<BR>Current Config Element: $vals:<br> " . stripSlashesConditional($$vals) . "<br>";
		
	}


	return $sessionVar;

}



















/*
Author: Jan, Nilesh, Matthew
Date: 3/26/2005

Desription:
	Used to pull related keywords from outside source.

Parameters:
	basekeyword: keyword we're pulling related data for.

	max_kw: max number of keywords to pull.

Returns:
	An array with the status and potentially an array of keywords if successful.  
	The status is the first parameter indicating:
		0 = No keywords were found.
		1 = A number of keywords were found but they were lower than the maximum keywords specified.
		2 = Keywords were found in an amount equal to or great than the maximum requested.
		3 = There was an error contacting the remote server.

*/
function getRelatedKeywords($basekeyword, $max_kw = 10) {

	global $messages;

	$kw_content = @file("http://inventory.overture.com/d/searchinventory/suggestion/?term=". urlencode($basekeyword));

	if($kw_content) {

		$page = implode("", $kw_content);
		preg_match_all("/sans-serif\" size=1>&nbsp;(.+?)<\/td>(.+?)size=1 color=#000000>(.+?)<\/a>/is", $page, $kwords);
		$kw_count = 1;

		while (list($kid,$kw) = each($kwords[3])) {
			
			if($kw_count > $max_kw) {
				break;
			}

			$keysd[] = cleantext($kw);
			$kw_count++;
			/*
			//unset($kw_content);
			//$kw_content = @file("http://inventory.overture.com/d/searchinventory/suggestion/?term=". urlencode($kw));
			

			if($kw_content) {
			
				
				$page = implode("", $kw_content);
				preg_match_all("/sans-serif\" size=1>&nbsp;(.+?)<\/td>(.+?)size=1 color=#000000>(.+?)<\/a>/is", $page, $kwords2);

				while (list($kid2,$kw2) = each($kwords2[3])) {
					
					$keysd[] = cleantext($kw2);
					$kw_count++;

					if($kw_count > $max_kw) {
						break;
					}

				}
			

			} else {
			
				break;

			}

			*/



		}
		

		
	
		if (count($keysd) == 0)	{

			return Array(0, $keysd);
		
		} else {

			sort($keysd);
			$keysd = array_unique($keysd);
			$keys = cleantext(implode("\n", $keysd));

			if(count($keysd) < $max_kw) {
				
				return Array(1, $keysd);

			} else {
			
				return Array(2, $keysd);

			}


		}
	
	
	
	
	
	} else {

		return Array(3, $keysd);

	}

	
}



function setupCheck() {
	
	// xml vars from config.inc.php, config file.
	global $appVersion;

	// Used to make sure the help is availab.e
	$arrHelp = array();


	// check if correct browser is being used on the correct OS.
	$browserUserAgent = strtoupper(getenv("HTTP_USER_AGENT"));
	if ( !(
			(
			 eregi("MSIE", $browserUserAgent) ||
			 eregi("Internet Explorer", $browserUserAgent)
			) &&
			 eregi("6", $browserUserAgent)
		   )
		) {
			echo "<span class='error'><b>Warning:</b> ~~appName~~ has been designed to work with Internet Explorer 6.0 or greater.  The application may not work properly if you do not use IE 6.0 or greater.<br><br>Thank you</span><br><br>";
		}




	// check if the main application settings file exists.
	if (!file_exists(APPSETTINGS_FILENAME)) {
		echo $messages["ApplicationSettingsFileDoesNotExist"] . "<br><br>";
	}


	


	// *********************************
	// Check the perms on the local dir.
	// *********************************
	$perms=substr(sprintf('%o', fileperms('./settings')), -4);

	if ($perms != "0755" && $perms != "0777" && $perms != "0733") {
		echo "<span class='error'><b>Warning:</b> You have not properly set permissions (755 or 733 or 0777) for the program's directory. This program will not function properly! Please adjust the permissions for the program's directory on your server or contact your systems admin to do this.<br><br>Thank you</span><br><br>";
		die();
	}
	// *********************************


	
	// *********************************
	// Check ftp perms and login info / ability.
	// *********************************
	
	$xml = new XML(APPSETTINGS_FILENAME);
	$xmlRemote = new XML(REMOTESETTINGS_FILENAME);

	$ftpLocal = new ftp();
	$ftpRemote = new ftp();
	
	$ftpLocal->debug = false;
	$ftpRemote->debug = false;

	$template_server_webroot = $xmlRemote->nodes["/applicationSettings[1]/template_server_webroot[1]"]["text"];

	$ftpServerRemote = $xmlRemote->nodes["/applicationSettings[1]/ftp[1]/provider[1]/server[1]"]["text"];
	$ftpServerLocal = $xml->nodes["/applicationSettings[1]/ftp[1]/customer[1]/server[1]"]["text"];

	$ftpUsernameRemote = $xmlRemote->nodes["/applicationSettings[1]/ftp[1]/provider[1]/username[1]"]["text"];
	$ftpUsernameLocal = $xml->nodes["/applicationSettings[1]/ftp[1]/customer[1]/username[1]"]["text"];
	
	$ftpPasswordRemote = $xmlRemote->nodes["/applicationSettings[1]/ftp[1]/provider[1]/password[1]"]["text"];
	$ftpPasswordLocal = $xml->nodes["/applicationSettings[1]/ftp[1]/customer[1]/password[1]"]["text"];
	
	$webRootRemote = $xmlRemote->nodes["/applicationSettings[1]/ftp[1]/provider[1]/webRoot[1]"]["text"];
	$webRootLocal = $xml->nodes["/applicationSettings[1]/ftp[1]/customer[1]/webRoot[1]"]["text"];
	
	// ************************************************************
	// FTP check operations for local server.
	if (!$ftpLocal->ftp_connect($ftpServerLocal)) { 
	
		echo "<span class='error'><b>Warning:</b> The application was not able to connect to your local FTP server.  Please make sure that a local application can access your local FTP server.  The application cannot continue without being able to connect to the local FTP server.  Perhaps another server address is needed or the server administrator must be contacted.<br><br>Thank you</span><br><br>";

		die();

	} else {
		
		if (!$ftpLocal->ftp_login($ftpUsernameLocal, $ftpPasswordLocal)) {
			echo "<span class='error'><b>Warning:</b> You have changed the FTP access information to your server.  ~~appName~~ will no longer work properly.  Please contact ~~appName~~ Technical support. Error: FTP Information Changed.<br><br>Thank you</span><br><br>";
			die();

		} else {

			// change to web root if a value was set (may just put you right in the web root by default).
			if (!$ftpLocal->ftp_chdir($webRootLocal)) {
				echo "<span class='error'><b>Warning:</b> The configured web root directory for your local server (local FTP server) was not found.  ~~appName~~ will not work properly.  The currently configured web root directory is: " . $webRootLocal . ".  Please double check this directory name and reinstall ~~appName~~ software if found to be in error. If the web root directory name is correct, or this problem persists please contact ~~appName~~ Technical Support.  Error: Invalid Web Root.<br><br>Thank you</span>";

				die();
			}
		}

	}
	// ************************************************************



	// ************************************************************	
	// FTP check operations for remote server.
	// ************************************************************
	if (!$ftpRemote->ftp_connect($ftpServerRemote)) { 
	
		echo "<span class='error'><b>Warning:</b> The application was not able to connect to your REMOTE FTP server ($ftpServerRemote) for the application's FTP.  Perhaps another server address is needed or technical support must be contacted.<br><br>Thank you</span><br><br>";
		die();

	} else {
		
		if (!$ftpRemote->ftp_login($ftpUsernameRemote, $ftpPasswordRemote)) {
			echo "<span class='error'><b>Warning:</b> The FTP login information for the remote ~~appName~~ FTP server is incorrect.  Please contact ~~appName~~ technical support for the correct info.<br><br>Thank you</span><br><br>";
			die();
		} else {

			// change to web root if a value was set (may just put you right in the web root by default).
			if (!$ftpRemote->ftp_chdir($template_server_webroot)) {
				echo "<span class='error'><b>Warning:</b> The configured ~~appName~~ template server web root was not found by the application.  The currently configured web root directory is: " . $template_server_webroot . ".  Please contact ~~appName~~ technical support.<br><br>Thank you</span><br><br>";
				die();
			}
		}

	}
	// ************************************************************



	// ************************************************************	
	// Check if the help system is available.
	// ************************************************************

	$arrXmlHelp = @getXmlHelp("step1");

	if (count($arrXmlHelp) == 0 || !$arrXmlHelp) {
		echo "<span class='error'><b>Warning:</b> Error message: The ~~appName~~ Help server is temporarily unavailable.  ~~appName~~ may function properly, but the Help features are not available.  Please try again later if you require this feature.  If you continue to receive this error message and this is a concern, please contact ~~appName~~ Support. This will not affect the operation of the program.<br><br>Thank you</span><br><br>";
	}

	// ************************************************************



}



function list_saved_sessions() {

	$arrSessions = array();
	$xml = new XML("./settings/sessions.xml");

	$arrSessions = @array_keys($xml->nodes["/sessions[1]"]["children"]);

	return $arrSessions;

}



/*
 * Pulls the text to display on the toip of the page from the remote location.
 */
function get_headerText($step) {

	$xmlLocal = new XML(REMOTESETTINGS_FILENAME);

	$remoteApplicationSettingsLocation = $xmlLocal->nodes["/applicationSettings[1]/remoteApplicationSettings[1]/remoteApplicationSettingsLocation[1]"]["text"];

	$xmlLocal = null;


	$xmlRemote = @new XML($remoteApplicationSettingsLocation);

	if ($xmlRemote) {
		$ret = @$xmlLocal->nodes["/remoteApplicationSettings[1]/" . $step . "[1]/headerText[1]"]["text"];
	}

	
	if ($ret) {
		return $ret;
	} else {
		return false;
	}


}





/*
 * gets the list of related sub directories.
 */
function getSubDirs() {

	$dirs = array();
	$dirsList = array();
	$xml = 
	new XML("./settings/subDirectories.xml");

	// get all the names for the children of the parent session and step we need.
	$dirs = array_keys($xml->nodes["/folders[1]"]["children"]);

	for ($i=0; $i<count($dirs); $i++) {

		$dirList[$i] = "/" . $dirs[$i] . "/" . $xml->nodes["/folders[1]/" . $dirs[$i] . "[1]"]["attributes"]["indexPage"] . "~~" . $xml->nodes["/folders[1]/" . $dirs[$i] . "[1]"]["attributes"]["text"];
	}

	return $dirList;
 }





function getTemplateHtml($selTemplate, $selCategory, $arrPages, $subDirectory, $thisSession) {

	$xml = new XML(APPSETTINGS_FILENAME);
	$xmlRemote = new XML(REMOTESETTINGS_FILENAME);
	$ftpLocal = new ftp();
	$ftpRemote = new ftp();

	$ftpLocal->debug = false;
	$ftpRemote->debug = false;
	
	global $steps, $config_fields, $template_server_for_web;

	$template_server_webroot = $xmlRemote->nodes["/applicationSettings[1]/template_server_webroot[1]"]["text"];

	$ftpServerRemote = $xmlRemote->nodes["/applicationSettings[1]/ftp[1]/provider[1]/server[1]"]["text"];
	$ftpServerLocal = $xml->nodes["/applicationSettings[1]/ftp[1]/customer[1]/server[1]"]["text"];

	$ftpUsernameRemote = $xmlRemote->nodes["/applicationSettings[1]/ftp[1]/provider[1]/username[1]"]["text"];
	$ftpUsernameLocal = $xml->nodes["/applicationSettings[1]/ftp[1]/customer[1]/username[1]"]["text"];
	
	$ftpPasswordRemote = $xmlRemote->nodes["/applicationSettings[1]/ftp[1]/provider[1]/password[1]"]["text"];
	$ftpPasswordLocal = $xml->nodes["/applicationSettings[1]/ftp[1]/customer[1]/password[1]"]["text"];
	
	$webRootRemote = $xmlRemote->nodes["/applicationSettings[1]/ftp[1]/provider[1]/webRoot[1]"]["text"];
	$webRootLocal = $xml->nodes["/applicationSettings[1]/ftp[1]/customer[1]/webRoot[1]"]["text"];

	// get the needed filename extension
	$fileExtension = substr($thisSession["step3"]["indexFilename"], strrpos($thisSession["step3"]["indexFilename"], "."), strlen($thisSession["step3"]["indexFilename"]));
	
	// ************************************************************
	// operations for local server.
	// log into the local ftp server to upload files.

	if (!$ftpLocal->ftp_connect($ftpServerLocal)) { return false; }
	if (!$ftpLocal->ftp_login($ftpUsernameLocal, $ftpPasswordLocal)) { return false; }

	// change to web root if a value was set (may just put you right in the web root by default).
	if ($webRootLocal) {
		if (!$ftpLocal->ftp_chdir($webRootLocal)) { return false; }
	}

	// create designated sub-dir.
	$ftpLocal->ftp_mkdir($subDirectory);
	$ftpLocal->ftp_mkdir($subDirectory . "/images");

	// set perms to write files to directory.
	if (!$ftpLocal->ftp_site("chmod 733 " . $subDirectory)) { return false; }
	if (!$ftpLocal->ftp_site("chmod 733 " . $subDirectory . "/images")) { return false; }
	
	// ************************************************************


	// ************************************************************	
	// FTP operations for remote server.
	// log into the local ftp server to upload files.
	if (!$ftpRemote->ftp_connect($ftpServerRemote)) { return false; }
	if (!$ftpRemote->ftp_login($ftpUsernameRemote, $ftpPasswordRemote)) { return false; }

	// change to the template dir
	if (!$ftpRemote->ftp_chdir($template_server_webroot . "/" . $selCategory . "/" . $selTemplate)) { return false; }
	// get and download all the files for the images dir.	
	ftpDir("images", "../" . $subDirectory . "/images", $ftpRemote);

	// ************************************************************


	// ************************************************************
	// get the template(s)' HTML via the web.
	
	for ($i=0 ; $i<count($arrPages) ;$i++) {
		$htmlPageText[$i] = stripSlashes(file_get_contents("$template_server_for_web/$selCategory/$selTemplate/" . $arrPages[$i], "r"));
	}	
	// ************************************************************

	

	// *****************************************************************************************************
	// Now some more specific code for the pop up window feeds.	
	if($thisSession["step5"]["addPopUp"] == "1")
	{

		switch ($thisSession["step5"]["popUpType"]) {

			case "entrance":
				$popUpText = " onLoad=\"window.open('" . $thisSession["step5"]["popUpUrl"] . "')\" ";
	
			case "exit":
				$popUpText = " onUnload=\"window.open('" . $thisSession["step5"]["popUpUrl"] . "')\"";
		}

	}



	// *****************************************************************************************************
	// ADDING THE RSS TEXT TO THE PAGES.
	for ($i=0 ; $i<count($arrPages) ;$i++) {
		$htmlPageText[$i] = str_replace("~~addPopUp~~", $popUpText, $htmlPageText[$i]);
	}
	// *****************************************************************************************************


	// *****************************************************************************************************
	// IP OF THE CURRENT SERVER, SWAP OUT THE MARKER ~~ip~~
	for ($i=0 ; $i<count($arrPages) ;$i++) {
		$htmlPageText[$i] = str_replace("~~ip~~", $_SERVER["SERVER_ADDR"], $htmlPageText[$i]);
	}
	// *****************************************************************************************************


	// *****************************************************************************************************
	// adding the Google code text to the page.
	if ($thisSession["step5"]["googleOn"] == "1") {

		for ($i=0 ; $i<count($arrPages) ;$i++) {
			$htmlPageText[$i] = str_replace("~~googleCode~~", $thisSession["step5"]["googleCode"], $htmlPageText[$i]);
		}

	}
	// *****************************************************************************************************

	

	// *****************************************************************************************************
	// adding the "extra html" textbox text from step 4.
	// *****************************************************************************************************
	if ($thisSession["step5"]["extraHtmlOn"] == "1") {
		
		for ($i=0 ; $i<count($arrPages) ;$i++) {
			$htmlPageText[$i] = str_replace("~~extraHtmlCode~~", $thisSession["step5"]["extraHtmlCode"], $htmlPageText[$i]);	
		}

	}
	// *****************************************************************************************************

	

	// *****************************************************************************************************
	// Generate list of links for links to the keywords pages.
	// *****************************************************************************************************

	$arrKeywords = explode("\n", $thisSession["step1"]["keywords"]);

	for ($i=0; $i<count($arrKeywords); $i++) {
		
		if ($arrKeywords[$i] != "") {
			// removes invalid chars, make it more viewer and user fiendly.  A straight URLEncode wouldn't work as I need to write the 
			// disk to the harddrive and we'd end up with "%" etc in the filename, not user-fiendly.  So we wrote a custom function
			// "convert_filename"
			$keywordsFilename = convert_filename($arrKeywords[$i]);
			$keywordsPagesLinkHtml .= "<A HREF='" . $keywordsFilename[0] . $fileExtension . "'>"  . $arrKeywords[$i] .  "</a><BR>\n";
		}

	}

	for ($i=0 ; $i<count($arrPages) ;$i++) {
		$htmlPageText[$i] = str_replace("~~nextKeyword~~", $keywordsPagesLinkHtml, $htmlPageText[$i]);
	}
	// *****************************************************************************************************






	// *****************************************************************************************************
	// now the related directories,
	// *****************************************************************************************************
	$arrRelatedDirs = $thisSession["step3"]["relatedDirs"];

	for ($i=0; $i<count($arrRelatedDirs); $i++) {

		// split up the friendly name to the dir name. dir name first. I use ~~ as a delimited between the human name and the actual dir name.
		$arr = split("~~", $arrRelatedDirs[$i]);
		if ($arrRelatedDirs[$i] != "") {
			$relatedDirsHtml .= "<A HREF='" . $arr[0] . "'>"  . $arr[1] .  "</a><BR>";
		}
	}

	
	for ($i=0 ; $i<count($arrPages) ;$i++) {
		$htmlPageText[$i] = str_replace("~~relatedDirs~~", $relatedDirsHtml, $htmlPageText[$i]);
	}
	// *****************************************************************************************************






	// *****************************************************************************************************
	// swap out the word "keyword" in the meta description with the "~~keyword~~" placeholder.
	// *****************************************************************************************************
	// set the var so it contains the correct marker.
	$thisSession["step4"]["metaDesc"] = 
		str_replace("keyword", "~~keyword~~", 
		// I do this line in case it's a refresh otherwise we keep building up "~" in the text.
		str_replace("~", "", $thisSession["step4"]["metaDesc"]) 
	);
	

	for ($i=0 ; $i<count($arrPages) ;$i++) {
		$htmlPageText[$i] = str_replace("~~metaDesc~~", $thisSession["step4"]["metaDesc"], $htmlPageText[$i]);
	}
	// *****************************************************************************************************
	



	// *****************************************************************************************************
	// swap out the images footer, keyword, header as needed.
	// *****************************************************************************************************
	if ($thisSession["step6"]["headerImageUrl"]!= "") {
		for ($i=0 ; $i<count($arrPages) ;$i++) { 
			$htmlPageText[$i] = str_replace("~~headerImageUrl~~", $thisSession["step6"]["headerImageUrl"], $htmlPageText[$i]); 
		}		
	} else {
		for ($i=0 ; $i<count($arrPages) ;$i++) { 
			$htmlPageText[$i] = str_replace("~~headerImageUrl~~", "images/spacer.gif", $htmlPageText[$i]); 
		}
	}
	


		if ($thisSession["step6"]["keywordImageUrl"]!= "") {
			for ($i=0 ; $i<count($arrPages) ;$i++) { 
				$htmlPageText[$i] = str_replace("~~keywordImageUrl~~", $thisSession["step6"]["keywordImageUrl"], $htmlPageText[$i]); 
			}		
		} else {
			for ($i=0 ; $i<count($arrPages) ;$i++) { 
				$htmlPageText[$i] = str_replace("~~keywordImageUrl~~", "images/spacer.gif", $htmlPageText[$i]); 
			}
		}


	if ($thisSession["step6"]["footerImageUrl"]!= "") {
		for ($i=0 ; $i<count($arrPages) ;$i++) { 
			$htmlPageText[$i] = str_replace("~~footerImageUrl~~", $thisSession["step6"]["footerImageUrl"], $htmlPageText[$i]); 
		}		
	} else {
		for ($i=0 ; $i<count($arrPages) ;$i++) { 
			$htmlPageText[$i] = str_replace("~~footerImageUrl~~", "images/spacer.gif", $htmlPageText[$i]); 
		}
	}





	// *****************************************************************************************************




	// **************************************************************************************************************
	// Generate converted HTML.  This block of code must come after you're done the custom swapping of tags above.
	// The reason for this is the config file will swap the custom elements incorrectly (usually blank) if the custom
	// replacements are not already done above.

	// array of elements we don't process, usually because they're processed while producing the files with keyword replacement etc.
	$arrExclude = Array( 'externalLinks', 'rssOn', 'relatedSites', 'ppcSearchFeed', 'ppcRevPilot', 'googleCode', 'extraHtmlCode' );
	// fields that are on / off fields instead of custom configured.
	$arrBooleanFields = Array( 'searchGoogle', 'searchMsn', 'searchAskJeeves', 'searchLookSmart', 'searchDmoz', 'searchYahoo', 'searchSearchAlot', 'searchEarthlink', 'searchMamma', 'searchDogPile', 'searchAol', 'searchIWon', 'searchSearchre', 'searchOverture');



	reset($steps);
	// loop through the steps.
	while(list($stepsKey, $stepsVal) = each($steps)) {
		
		// I reset the pointer to the first value in case we've cycled through this array in another function since this is a global var.
		reset($config_fields[$stepsVal]);
	
		while(list($elementsKey, $elementsVal) = each($config_fields[$stepsVal])) {

			//echo $elementsVal . " : " . $thisSession[$stepsVal][$elementsVal] . "<br>";

			// However if the value equals "1" then it's just a boolean saying use the value within the config file (XML).
			// so then we don't pull it from the page.
			if ( isset($thisSession[$stepsVal][$elementsVal]) ) {

					// exclude elements not to be processed.
					if ( !in_array($elementsVal, $arrExclude) ) {

						// loop through all the pages to replace the value.
						if (trim($thisSession[$stepsVal][$elementsVal]) != "1" && trim($thisSession[$stepsVal][$elementsVal]) != "") { 
							for ($i=0 ; $i<count($arrPages) ;$i++) {
								$htmlPageText[$i] = str_replace("~~" . $elementsVal . "~~", $thisSession[$steps[$stepsKey]][$elementsVal], $htmlPageText[$i]);
							}
						} elseif (trim($thisSession[$stepsVal][$elementsVal]) == "1") { // == 1 would mean a turn on / off marker for a tag, does not contain actual text, this is pulled from the config file (remote config).
							for ($i=0 ; $i<count($arrPages) ;$i++) {
								$htmlPageText[$i] = str_replace("~~" . $elementsVal . "~~", $xmlRemote->nodes["/applicationSettings[1]/template_flags[1]/" . $elementsVal . "[1]"]["text"], $htmlPageText[$i]);
							}
						} elseif (in_array($elementsVal, $arrBooleanFields)) { 
							// is this a checkbox? have to clear out to prevent further processing.
							// checkboxes do not pass themselve AT ALL if not checked, so no checking for "" works.
							for ($i=0 ; $i<count($arrPages) ;$i++) {
								$htmlPageText[$i] = str_replace("~~" . $elementsVal . "~~", "", $htmlPageText[$i]);
							}
						}

					}

			// one of the checkbox fields and just needs to be cleared out as no value is present if we get here.
			} elseif ( in_array($elementsVal, $arrBooleanFields) ) {
				for ($i=0 ; $i<count($arrPages) ;$i++) {
					$htmlPageText[$i] = str_replace("~~" . $elementsVal . "~~", "", $htmlPageText[$i]);
				}
			}


		}


	}





	// loop through the XML fields.
	while(list($xmlKey, $xmlVal) = each($xmlRemote->nodes["/applicationSettings[1]/template_flags[1]"]["children"])) {

		// exclude elements not to be processed.
		if ( !in_array($xmlKey, $arrExclude) ) {

			// loop through all the pages to replace the value.
			for ($i=0 ; $i<count($arrPages) ;$i++) {
				//echo "xml key: " . $xmlKey . " --- " . $xmlRemote->nodes["/applicationSettings[1]/template_flags[1]/" . $xmlKey . "[1]"]["text"] . " xml text<br>";
				 $htmlPageText[$i] = str_replace("~~" . $xmlKey . "~~", $xmlRemote->nodes["/applicationSettings[1]/template_flags[1]/" . $xmlKey . "[1]"]["text"], $htmlPageText[$i]);
			}

		}

	}



	// starting from the top of the list of steps.
	reset($steps);
	// now we loop through it again to parse out any tags used from the session.
	while(list($stepsKey, $stepsVal) = each($steps)) {
		
		// I reset the pointer to the first value in case we've cycled through this array in another function since this is a global var.
		reset($config_fields[$stepsVal]);
	
		while(list($elementsKey, $elementsVal) = each($config_fields[$stepsVal])) {

			//echo $elementsVal . " : " . $thisSession[$stepsVal][$elementsVal] . "<br>";

			// However if the value equals "1" then it's just a boolean saying use the value within the config file (XML).
			// so then we don't pull it from the page.
			if ( isset($thisSession[$stepsVal][$elementsVal]) ) {

					// exclude elements not to be processed.
					if ( !in_array($elementsVal, $arrExclude) ) {

						// loop through all the pages to replace the value.
						for ($i=0 ; $i<count($arrPages) ;$i++) {
							$htmlPageText[$i] = str_replace("~~" . $elementsVal . "~~", $thisSession[$steps[$stepsKey]][$elementsVal], $htmlPageText[$i]);
						}

					}


			}

		}


	}






	// *****************************************************************************************************
	// now the KEYWORD IMAGE swapped for the marker please note I must place this after the keyword text has
	// been placed within the page.  This will replace this image wherever it find it.
	// *****************************************************************************************************
	// now swap the image marker with the "~~keyword~~" marker.
	for ($i=0 ; $i<count($arrPages) ;$i++) {
		//echo $htmlPageText[$i] . "!!!!!!!!!!!!!!!!!!\n\n\n\n\n\n";
		$htmlPageText[$i] = eregi_replace("<IMG id=keywordImage[^>]*>", "~~keyword~~", $htmlPageText[$i]);
	}
	// *****************************************************************************************************



	// *****************************************************************************************************
	// We have a system based based marker that swaps in the CURRENT DOMAIN NAME.
	// *****************************************************************************************************
	for ($i=0 ; $i<count($arrPages) ;$i++) {
		$htmlPageText[$i] = str_replace("~~currentHost~~", $_SERVER["HTTP_HOST"], $htmlPageText[$i]);
	}
	// *****************************************************************************************************




	$ftpLocal->ftp_quit();
	$ftpRemote->ftp_quit();

	


	return $htmlPageText;


}






// get a list of files in a srcDir and download them to the destDir.
function ftpDir($srcDir, $destDir, $ftp) {

	if (!$ftp->ftp_chdir($srcDir)) { return false; }

	$arrFile = $ftp->ftp_nlist("", ".");

	if (!$arrFile) { return false; }

	// there might not be any images.
	if (is_array($arrFile)) {

		while(list($key, $val) = each($arrFile)) {
			@$ftp->ftp_get($destDir . "/" . $val, $val, FTP_BINARY);
			@$ftp->ftp_site("chmod 0755 $val");
		}

	}

	return true;

}





/*
	Creates the files with correct keyword settings on the server itself, actual files:
	$type = keyword or index
	$session = current user session var with session settings.
	$pageName = only applicable to the index page, what it will be named.
	$pageHtml = the HTML for the page itself.
*/
function createKeywordPages($thisSession, $pageHtml) {

	$xml = new XML(REMOTESETTINGS_FILENAME);	
	$subDirectory = $thisSession["step3"]["baseDir"];

	// create lastRSS object
	$objRss = new lastRSS; 

	// setup transparent cache
//	$objRss->cache_dir = './cache'; 
//	$objRss->cache_time = 3600; // one hour

	$arrKeywords = explode("\n", $thisSession["step1"]["keywords"]);
	// remove any blank items as needed and trim up the chars.
	for ($i=0; $i<count($arrKeywords) ; $i++) {
		
		if (strlen($arrKeywords[$i]) == 0) { 
			unset($arrKeywords[$i]); 
		} else {
			$arrKeywords[$i] = trim($arrKeywords[$i]);
		}

	}

	$arrKeywordPagesHtml = array();

	// pull the file extension from the index file name.
	$fileExtension = substr($thisSession["step3"]["indexFilename"], strrpos($thisSession["step3"]["indexFilename"], "."), strlen($thisSession["step3"]["indexFilename"]));
	
	// get an array, one index per each keyword.
	for ($i=0; $i<count($arrKeywords) ; $i++) {
		$arrKeywordPagesHtml[$i] = $pageHtml;
	}

	// if we're implementing linking the rss feeds to outside sources.
	$externalLinks = intval($thisSession["step4"]["externalLinks"]);
	// how the links will open.
	if ($thisSession["step4"]["openLinks"] == "1") {
		$htmlTarget = ""; // open in self.
	} else {
		$htmlTarget = " target='_blank' "; // open in new window.
	}
		



	// *****************************************************************************************************
	// Now some more specific code for the RSS feeds from step 4.	
	if ($thisSession["step5"]["rssOn"] != "none")
	{

		switch ($thisSession["step5"]["rssOn"]) {
			case "builtIn":
				$rssLink = $thisSession["step5"]["rssFeed"];
				break;
			case "custom":
				$rssLink = $thisSession["step5"]["rssCustomUrl"];
				break;
		}


		for ($i=0; $i<count($arrKeywords) ; $i++) {


				// load RSS file load elements into array **
				$rss = null;
				$rss = @$objRss->get( str_replace("~~keyword~~", urlencode($arrKeywords[$i]), $rssLink) );
				// reset the links var.
				$rssFeedText = "";

				if (!$rss) { continue; }

				// while the loop is less than the total items available and less than the chosen number of links.
				for ($rss_i = 0; $rss_i < count($rss[items]) && $rss_i < $thisSession["step5"]["rssLinkCount"]; $rss_i++) {

					// gives elements.
					$item = $rss[items][$rss_i];
					if (count($item)) {
						$rssFeedText .= "<a href='$item[link]'" . $htmlTarget . ">". unhtmlentities($item[title]) ."</a><br>".  unhtmlentities($item[description]) ."<br><br>\n";
					}

				}

				$arrKeywordPagesHtml[$i] = str_replace("~~rssOn~~", $rssFeedText, $arrKeywordPagesHtml[$i]);
		
		
		}


	}
	// *****************************************************************************************************



	// *****************************************************************************************************
	// Generate list of RELATED SITES (links).
	// *****************************************************************************************************

	if (intval($thisSession["step4"]["relatedSitesCount"]) > 0) {

		for ($i=0; $i<count($arrKeywords) ; $i++) {

				// load RSS file load elements into array **
				$rss = null;

				// set up link as needed.
				$rssLink = str_replace("~~keyword~~", urlencode($arrKeywords[$i]), $xml->nodes["/applicationSettings[1]/relatedSitesRss[1]"]["text"]);
				$rssLink = str_replace("~~relatedSitesCount~~", $thisSession["step4"]["relatedSitesCount"], $rssLink);

				$rss = @$objRss->get($rssLink);
				// reset the links var.
				$rssFeedText = "";

				if (!$rss) { continue; };


				// while the loop is less than the total items available and less than the chosen number of links.
				for ($rss_i = 0; $rss_i <= count($rss["items"]) && $rss_i < intval($thisSession["step4"]["relatedSitesCount"]); $rss_i++) {

					// gives elements.
					$item = $rss[items][$rss_i];  

					if (count($item)) {

						
						if ($externalLinks) {
							$rssFeedText .= "<a href='$item[link]'" . $htmlTarget . ">". unhtmlentities($item[title]) ."</a><br>".  unhtmlentities($item[description]) ."<br><br>\n";
						} else { 
							$rssFeedText .= "<b>" . unhtmlentities($item[title]) ."</b><br>".  unhtmlentities($item[description]) ."<br><br>\n"; 
						}
						
						
					}
				}

				$arrKeywordPagesHtml[$i] = str_replace("~~relatedSites~~", $rssFeedText, $arrKeywordPagesHtml[$i]);		
		
		}	

	
	// make sure to clear out the marker if no sites were chosen.
	} else {

		for ($i=0; $i<count($arrKeywords) ; $i++) { $arrKeywordPagesHtml[$i] = str_replace("~~relatedSites~~", "", $arrKeywordPagesHtml[$i]); }	

	}

	// *****************************************************************************************************


	



	// *****************************************************************************************************
	// PPC Rss feeds.
	// *****************************************************************************************************

	if ($thisSession["step5"]["ppcOn"] == "1") {


		for ($i=0; $i<count($arrKeywords) ; $i++) {

				$rssUrl = $xml->nodes["/applicationSettings[1]/ppcSearchFeedRss[1]"]["text"];
				$rssUrl = str_replace("~~ppcLinksPerPage~~", $thisSession["step5"]["ppcLinksPerPage"], $rssUrl);
				$rssUrl = str_replace("~~searchFeedId~~", $thisSession["step5"]["searchFeedId"], $rssUrl);
				$rssUrl = str_replace("~~searchFeedTrackId~~", $thisSession["step5"]["searchFeedTrackId"], $rssUrl);
				$rssUrl = str_replace("~~ip~~", $_SERVER["SERVER_ADDR"], $rssUrl);

				// create RSS for this particular keyword on PPC Search feed.
				if ($thisSession["step5"]["ppcSearchFeed"] == "1") {

						for ($i=0; $i<count($arrKeywords) ; $i++) {

								// load RSS file load elements into array **
								$xmlRss = null;
								// reset the links var.
								$rssFeedText = "";


								$xmlRss = new XML(str_replace("~~keyword~~", urlencode($arrKeywords[$i]), $rssUrl), false);
								if (!$xmlRss) { continue; }


								// while the loop is less than the total items available and less than the chosen number of links.
								for ($rss_i = 0; $rss_i <= count($xmlRss->nodes["/Listings[1]"]["children"]) && $rss_i < intval($thisSession["step5"]["ppcLinksPerPage"]); $rss_i++) {

									if (!$xmlRss->nodes["/Listings[1]/Listing[" . ($rss_i+1) ."]/URI[1]"]["text"]) { continue; }

										$rssFeedText .= "<a href='" . $xmlRss->nodes["/Listings[1]/Listing[" . ($rss_i+1) ."]/URI[1]"]["text"] . "'" . $htmlTarget . ">";
										$rssFeedText .= unhtmlentities($xmlRss->nodes["/Listings[1]/Listing[" . ($rss_i+1) ."]/Title[1]"]["text"]) . ", ";
										$rssFeedText .= $xmlRss->nodes["/Listings[1]/Listing[" . ($rss_i+1) ."]/URL[1]"]["text"];
										$rssFeedText .= "</a><br>";
										$rssFeedText .= unhtmlentities($xmlRss->nodes["/Listings[1]/Listing[" . ($rss_i+1) ."]/Description[1]"]["text"]) ."<br><br>\n";

									}

								$arrKeywordPagesHtml[$i] = str_replace("~~ppcSearchFeed~~", $rssFeedText, $arrKeywordPagesHtml[$i]);		
						}

				}




				// create RSS for this particular keyword on PPC Search feed.
				if ($thisSession["step5"]["ppcRevPilot"] == "1") {

						$rssUrl = $xml->nodes["/applicationSettings[1]/revenuePilotRss[1]"]["text"];
						$rssUrl = str_replace("~~ppcLinksPerPage~~", $thisSession["step5"]["ppcLinksPerPage"], $rssUrl);
						$rssUrl = str_replace("~~revPilotId~~", $thisSession["step5"]["revPilotId"], $rssUrl);
						$rssUrl = str_replace("~~ip~~", $_SERVER["SERVER_ADDR"], $rssUrl);

						for ($i=0; $i<count($arrKeywords) ; $i++) {

								// load RSS file load elements into array **
								$xmlRss = null;
								// reset the links var.
								$rssFeedText = "";


								$xmlRss = @new XML(str_replace("~~keyword~~", urlencode($arrKeywords[$i]), $rssUrl), false);
								if (!$xmlRss) { continue; }


								// while the loop is less than the total items available and less than the chosen number of links.
								for ($rss_i = 0; $rss_i <= count($xmlRss->nodes["/RESULTS[1]"]["children"]) && $rss_i < intval($thisSession["step5"]["ppcLinksPerPage"]); $rss_i++) {

									if (!$xmlRss->nodes["/RESULTS[1]/LISTING[" . ($rss_i+1) ."]"]["attributes"]["LINK"]) { continue; }
																		
									$rssFeedText .= "<a href='" . $xmlRss->nodes["/RESULTS[1]/LISTING[" . ($rss_i+1) ."]"]["attributes"]["LINK"] . "'" . $htmlTarget . ">";
									$rssFeedText .= unhtmlentities($xmlRss->nodes["/RESULTS[1]/LISTING[" . ($rss_i+1) ."]"]["attributes"]["TITLE"] )."</a><br>";
									$rssFeedText .= unhtmlentities($xmlRss->nodes["/RESULTS[1]/LISTING[" . ($rss_i+1) ."]"]["attributes"]["DESCRIPTION"]) ."<br><br>\n";

								}

								$arrKeywordPagesHtml[$i] = str_replace("~~ppcRevPilot~~", $rssFeedText, $arrKeywordPagesHtml[$i]);		
	
						}

				}

		
		}





	}
	// *******************************************************************************************************


	// *******************************************************************************************************
	// Now cycle through the keywords to replace all ~~keyword~~ markers with the keyword itself.
	// *******************************************************************************************************

	for ($i=0; $i<count($arrKeywords) ; $i++) {

		$arrKeywordPagesHtml[$i] = str_replace(
												"~~keyword~~", 
												$arrKeywords[$i],
												$arrKeywordPagesHtml[$i]
											   );
	}

	// *******************************************************************************************************





	// *****************************************************************************************************
	// now the NEW LINE CHAR MARKER.
	// *****************************************************************************************************
	for ($i=0 ; $i<count($arrKeywords) ;$i++) {		
		$arrKeywordPagesHtml[$i] = str_replace("||||", "\n", $arrKeywordPagesHtml[$i]);
	}
	// *****************************************************************************************************

 



	// *****************************************************************************************************
	// Now we get a random list of keywords for each keywords page..
	// *****************************************************************************************************
	for ($i=0 ; $i<count($arrKeywords) ;$i++) {		
		$rdmKeywords = createRandomPagesLinks($arrKeywords, "<BR>\n", 15, $fileExtension);
		$arrKeywordPagesHtml[$i] = str_replace("~~randomKeywordPageLinks~~", $rdmKeywords , $arrKeywordPagesHtml[$i]);
	}
	// *****************************************************************************************************


	// *****************************************************************************************************
	// Now we get a random list of keywords for each keywords page, but with a horizontal alignment format.
	// *****************************************************************************************************
	for ($i=0 ; $i<count($arrKeywords) ;$i++) {		
		$rdmKeywords = createRandomPagesLinks($arrKeywords, "&nbsp;", 15, $fileExtension);
		$arrKeywordPagesHtml[$i] = str_replace("~~randomKeywordPageLinksHorizontal~~", $rdmKeywords , $arrKeywordPagesHtml[$i]);
	}
	// *****************************************************************************************************



	// *****************************************************************************************************
	// Clean out extra slashes and whatever we may like to clean out.
	// *****************************************************************************************************
	//array_walk($arrKeywordPagesHtml, "cleanArray");
	// *****************************************************************************************************



	// *****************************************************************************************************
	// Now strip out any extra tags that were not used.
	// *****************************************************************************************************
	for ($i=0 ; $i<count($arrKeywords) ;$i++) {		
		$arrKeywordPagesHtml[$i] = remove_unused_markers($arrKeywordPagesHtml[$i]);
	}
	// *****************************************************************************************************




	for ($i=0 ; $i<count($arrKeywords) ;$i++) {
		// remove incompatible chars.		
		$filename = convert_filename($arrKeywords[$i]);

		$fpDest[$i] = fopen("../$subDirectory/" . trim($filename[0]) . $fileExtension, "w+");

		if ($fpDest[$i]) { 
			fwrite($fpDest[$i], $arrKeywordPagesHtml[$i]);
		}

	}	




	return true;

}





// used for an array walk cleanup.
function cleanArray(&$item, $key) 
{
   $item = stripSlashesConditional($item);
}

// checks if Magic Quotes is on when stripping details.
function stripSlashesConditional($text) {
	
	if (get_magic_quotes_gpc()==1) {
		return stripslashes($text);
	} else {
		return $text;
	}

}


function createIndexPages($thisSession, $pageHtml) {

        $arrKeywords = explode("\n", $thisSession["step1"]["keywords"]);

		
		// remove any blank items as needed and trim up the chars.
		for ($i=0; $i<count($arrKeywords) ; $i++) {
			
			if (strlen($arrKeywords[$i]) == 0) { 
				unset($arrKeywords[$i]); 
			} else {
				$arrKeywords[$i] = trim($arrKeywords[$i]);
			}

		}


		// get the needed filename extension
		$fileExtension = substr($thisSession["step3"]["indexFilename"], strrpos($thisSession["step3"]["indexFilename"], "."), strlen($thisSession["step3"]["indexFilename"]));

		// get lists of keywords visually stacked on top of eachother every 50 keywords.		
		$arrKeywordsStacked = stackedKeywords($arrKeywords, 50, "<br>\n", $fileExtension);

		// ******************************************************************************************		
		// Processing for all pages to the root HTML.
		//$pageHtml = stripSlashesConditional($pageHtml);
		$pageHtml = str_replace("||||", "\n", $pageHtml);
		// ******************************************************************************************





		// ******************************************************************************************
		// CREATE DEFAULT INDEX PAGE.
		// ******************************************************************************************
		$filenameFullPath = "../" . $thisSession["step3"]["baseDir"] . "/" . $thisSession["step3"]["indexFilename"];

		// swap out the keyword marker.
        $htmlToWrite = str_replace("~~keyword~~", $arrKeywords[0], $pageHtml);
		$htmlToWrite = str_replace("~~keywordsListForIndexPages~~", $arrKeywordsStacked[0], $htmlToWrite);


				// *****************************************************************************************************
				// Now we get a random list of keywords for each keywords page..
				// *****************************************************************************************************
					$rdmKeywords = createRandomPagesLinks($arrKeywords, "<BR>\n", 25, $fileExtension);
					$htmlToWrite = str_replace("~~randomKeywordPageLinks~~", $rdmKeywords, $htmlToWrite);
				// *****************************************************************************************************


				// *****************************************************************************************************
				// Now we get a random list of keywords for each keywords page, but with a horizontal alignment format.
				// *****************************************************************************************************
					$rdmKeywords = createRandomPagesLinks($arrKeywords, "&nbsp;", 25, $fileExtension);
					$htmlToWrite = str_replace("~~randomKeywordPageLinksHorizontal~~", $rdmKeywords, $htmlToWrite);
				// *****************************************************************************************************



		$htmlToWrite = remove_unused_markers($htmlToWrite);
		$fpDest = fopen($filenameFullPath, "w+");
		fwrite($fpDest, $htmlToWrite);
		// ******************************************************************************************







		// need to create additional pages if more than this amount of keywords.
		if (count($arrKeywords) > 50) {

			// used to print out the stacked keywords per page.
			$iStack = 1;

			for ($i=1; $i < count($arrKeywords); $i += 50) {

				// swap out the keyword marker.
				$htmlToWrite = str_replace("~~keyword~~", $arrKeywords[$i], $pageHtml);

				$filename = convert_filename(str_replace(".", "_".$arrKeywords[$i].".", $thisSession["step3"]["indexFilename"]));
				$filenameFullPath = "../" . $thisSession["step3"]["baseDir"] . "/" . $filename[0];
				
				// **********************************************************************
				// ~~LINKS~~ REPLACEMENT, SPECIAL TAG FOR INDEX PAGES.  Getting a list of the keywords related to this keywords page.
				// **********************************************************************
				$htmlToWrite = str_replace("~~keywordsListForIndexPages~~", $arrKeywordsStacked[$iStack], $htmlToWrite);
				// **********************************************************************


				// random list of keywords links.
				$rdmKeywords = createRandomPagesLinks($arrKeywords, "<BR>\n", 25, $fileExtension);
				$htmlToWrite = str_replace("~~randomKeywordPageLinks~~", $rdmKeywords, $htmlToWrite);

				// random list of keywords links AGAIN, but with a horizontal alignment.
				$rdmKeywords = createRandomPagesLinks($arrKeywords, "&nbsp;", 25, $fileExtension);
				$htmlToWrite = str_replace("~~randomKeywordPageLinksHorizontal~~", $rdmKeywords, $htmlToWrite);


				// create the destination file with the correct name including the "_KEYWORDS".
				$fpDest = fopen($filenameFullPath, "w+");				

				// replace any straggler marker tags.
				$htmlToWrite = remove_unused_markers($htmlToWrite);
				fwrite($fpDest, $htmlToWrite);

				++$iStack;
		
			} 
		
		} 







}





function saveSession($sessionVar, $currentSessionName, $sessionNameToSave) {

	global $steps;
	global $config_fields; 

	$xml = new XML("./settings/sessions.xml");
	$session = $xml->nodes["/sessions[1]/" . $sessionNameToSave . "[1]"];

	// lists elements that we don't save to the sessions.xml file.
	$arrExclude = Array( 'relatedDirs', 'indexPageContent', 'keywordsPageContent', 'sessionName', 'saveSettings', 'saveType' );


	// check if parent element is there at all.
	if (!isset($xml->nodes["/sessions[1]/" . $sessionNameToSave . "[1]"])) {
		$xml->add_node ( "/sessions[1]", $sessionNameToSave );
	}




	for ($i=0; $i<count($steps); $i++) {

		for ($iSub=0; $iSub<count( $config_fields[$steps[$i]] ); $iSub++) {

			// if this particular field is not one we save. I do this for fields we don't want to repeat from a previous step.
			if ( in_array($config_fields[$steps[$i]][$iSub], $arrExclude) ) { continue; }


			$value = str_replace("\n", "||||", $sessionVar[$currentSessionName][ $steps[$i] ][ $config_fields[$steps[$i]][$iSub] ]);
			$path = "/sessions[1]/" . $sessionNameToSave . "[1]/" . $steps[$i] . "[1]/" . $config_fields[$steps[$i]][$iSub] . "[1]";


			// add the "step1, 2, 3, 4..." field to the xml file.
			if (!isset( $xml->nodes["/sessions[1]/" . $sessionNameToSave . "[1]/" . $steps[$i] . "[1]"] )) {
				$xml->add_node ( "/sessions[1]/" . $sessionNameToSave . "[1]", $steps[$i] );
			}

			// add the step itself, the form elements that is.
			if (!isset( $xml->nodes["/sessions[1]/" . $sessionNameToSave . "[1]/" . $steps[$i] . "[1]/" . $config_fields[$steps[$i]][$iSub] . "[1]"] )) {
				$xml->add_node ( "/sessions[1]/" . $sessionNameToSave . "[1]/" . $steps[$i] . "[1]", $config_fields[$steps[$i]][$iSub]);
			}
			
			// I encode this twice to defeat the XML's classes conversion of special HTML chars which I would not want to disable.
			$xml->set_content($path, htmlentities(htmlentities ($value)));
		}

	}


	// saving the current data to be the default as the last used session should be the default.
	return $xml->save();


}






/*
 * Creates a zip file of the designated dir. Assumed to be one 
 */
function createZipFile($directoryPath, $filename) {

		// delete a previously existing file if there.
		@unlink("./zipfiles/" . $filename);
		
		// zip the dir recursively.
		exec("zip -r ./zipfiles/"  . $filename, $directoryPath); 

		return true;
}








/*
function userErrorHandler($errno, $errmsg, $filename, $linenum, $vars)  {

		
	die("This process has timed out.  Please hit the refresh button or contact your systems administrator if this happens more than three times.<br><br>Thank you");

}
*/







// Save the dir we're creating our files in as a related dir.
function saveRelatedDir($newDirName, $indexPageName, $baseDirText) {

	global $messages;
	$arrAttributes =  Array();
	// create our attributes array.
	$arrAttributes["indexPage"] = $indexPageName;
	$arrAttributes["text"] = $baseDirText;

	$xml = new XML("./settings/subDirectories.xml");


	

	// get all the names for the children of the parent session and step we need.

	if ( !isset($xml->nodes["/folders[1]/" . $newDirName . "[1]"]["text"]) ) {
		$xml->add_node( "/folders[1]", $newDirName );
	}

	$xml->set_attributes("/folders[1]/" . $newDirName . "[1]", $arrAttributes);

	$xml->save();

}


/*
	creates a stack (visually a stack) of keywords.

	@arrKeywords = the array of keywords to stack.
	@amount = the number between stacks (where you get a new array element).
	@glue = the item between rows in the stack.
*/
function stackedKeywords($arrKeywords, $amount, $glue, $fileExtension) {

	// create the array of stacked up keywords.		
	$iStack = 0;
	for ($i=0; $i<count($arrKeywords); $i++) {			
		if ($i % $amount == 0 && $i != 0) { ++$iStack; }

		$filename = convert_filename($arrKeywords[$i]);
		$arrKeywordsStacked[$iStack] .= "<A HREF='" . $filename[0] . $fileExtension . "'>" . $arrKeywords[$i] . "</a>" . $glue;
	}

	
	return $arrKeywordsStacked;

}



/**************************************
Pulls help info from remote location. 
params: $step is the step you're on.
/**************************************/
function getXmlHelp($step) {

	global $help_server;
	$arrElements = Array();
	$arrElementsKeys = Array();
	$arrHelp = Array();

	$xml = new XML();
	$xml->turnErrorsOff = true;
	$xml->load_file($help_server . $step . "Help.xml");

	if ($xml) {

		$arrElements = array_keys($xml->nodes["/help[1]/" . $step . "[1]"]["children"]);

		for ($i=0; $i<count($arrElements); $i++) {
			$arrHelp[$arrElements[$i]] =  stripslashes(html_entity_decode($xml->nodes["/help[1]/" . $step . "[1]/" . $arrElements[$i] . "[1]"]["text"]));
			//echo $arrElements[$i] . " : " . $arrHelp[$arrElements[$i]] . "<br><br>";
		}

		return $arrHelp;

	} else {
		return false;
	}



}


?>
